/*
    tsync - a utility to sync remote encrypted copies of a tstore
    Copyright (C) 2005  Kasper Dupont

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    with permission from the author any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    $Id: tsync-create.c,v 1.6 2005/06/05 15:21:10 kasperd Exp $
*/

#include "tsync.h"

char cookie[44];
char pass[44];

#define RND_DEV "/dev/urandom"

void errstop(const char *s)
{
  perror(s);
  exit(EXIT_FAILURE);
}

void create_cookie_pass()
{
  uint8_t buf[100],t[3];
  int s=0;
  int fd=open(RND_DEV,O_RDONLY);
  if (fd==-1) errstop(RND_DEV);
  while (s<86) {
    int v=0;
    int i;
    while (v<3) {
      int r=read(fd,t+v,3-v);
      if (r<1) errstop(RND_DEV);
      v+=r;
    }
    for (i=0;i<3;++i)
      v=(v<<8)|t[i];
    for (i=0;i<4;++i) {
      int c=v&63;
      if (c<10) {
	buf[s++]=c+'0';
      } else if (c<10+26) {
	buf[s++]=c+('A'-10);
      } else if (c<10+26+26) {
	buf[s++]=c+('a'-10-26);
      }
      v=v>>6;
    }
  }
  close(fd);
  memcpy(cookie,buf,43);cookie[43]=0;
  memcpy(pass,buf+43,43);pass[43]=0;
}

int main(int argc, char ** argv)
{
  uint32_t header[16];
  int efd;

  if (argc != 2) {
    fprintf(stderr,"Usage: %s <encryptedstorage>\n",argv[0]);
    return EXIT_FAILURE;
  }

  create_cookie_pass();
  printf("Cookie=%s\nPass=%s\n",cookie,pass);

  efd=creat(argv[1],0666);
  if (efd == -1) errstop(argv[1]);

  strcpy((char*)header,"TSYNC-1");
  strcpy((char*)(header+2),cookie);
  header[13]=0; /* Should really be htonl(2) */
  header[14]=0;
  header[15]=0;

  write(efd,header,64);

  return 0;
}
