/*
    tsync - a utility to sync remote encrypted copies of a tstore
    Copyright (C) 2005  Kasper Dupont

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    with permission from the author any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef _TSYNC_H
#define _TSYNC_H

#define _GNU_SOURCE
#define _LARGEFILE_SOURCE  
#define _LARGEFILE64_SOURCE  
#define _FILE_OFFSET_BITS 64

#define _XOPEN_SOURCE 500

#include <stdint.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <ctype.h>
#include <assert.h>

#include <unistd.h>
#include <fcntl.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/mman.h>

#include <netinet/in.h>

void start_helper(int *rfd, int *wfd, char ** cmd);
void start_server(int *rfd, int *wfd, char ** cmd, uint32_t *record_count);
void start_gpg(int *rfd, int *wfd, char * pass, int encrypt);

static inline int64_t ntoh64(uint32_t *p)
{
  return
    (((uint64_t)ntohl(p[0]))<<32)|
    (((uint64_t)ntohl(p[1])));
}

static inline uint32_t* hton64(uint64_t v)
{
  static uint32_t r[2];
  r[0]=htonl(v>>32);
  r[1]=htonl(v);
  return r;
}

#endif
